#!/usr/bin/env python

# Copyright (C) 2010-2012 Daniele Varrazzo <daniele.varrazzo@gmail.com>
# All rights reserved.  See COPYING file for details.


import gevent
import gevent.monkey
gevent.monkey.patch_all()

import psycogreen.gevent
psycogreen.gevent.patch_psycopg()

import psycopg2

import logging
logging.basicConfig(level=logging.INFO, format="%(asctime)s %(message)s")
logger = logging.getLogger()
logger.info("testing psycopg2 with gevent")



conns = []

def fetch(secs, id):
    conn = psycopg2.connect("dbname=cqdb user=primea")
    conns.append(conn)
    cur = conn.cursor()
    logger.info("query %d start", id)
    cur.execute("select pg_sleep(%s)", (secs,))
    logger.info("query %d end", id)

logger.info("making jobs")
jobs = [
    gevent.spawn(fetch, 30, 1),
    gevent.spawn(fetch, 30, 2),
    ]

try:
    logger.info("join begin")
    gevent.joinall(jobs)
    logger.info("join end")
except (KeyboardInterrupt, Exception) as ex:
    print "Terminating..."
    for xx in conns:
        print xx.fileno()
        xx.cancel()
        xx.close()

